diff --git a/src/main/java/net/minecraft/client/render/model/ModelSpider.java b/src/main/java/net/minecraft/client/render/model/ModelSpider.java
index bf5ba0546..c685d7ca3 100644
--- a/src/main/java/net/minecraft/client/render/model/ModelSpider.java
+++ b/src/main/java/net/minecraft/client/render/model/ModelSpider.java
@@ -9,42 +9,41 @@ import net.minecraft.core.util.helper.MathHelper;
 public class ModelSpider extends ModelBase
 {
 
-    public ModelSpider()
+    public ModelSpider(float expandAmount)
     {
-        float f = 0.0F;
         int i = 15;
         spiderHead = new Cube(32, 4);
-        spiderHead.addBox(-4F, -4F, -8F, 8, 8, 8, f);
+        spiderHead.addBox(-4F, -4F, -8F, 8, 8, 8, expandAmount);
         spiderHead.setRotationPoint(0.0F, 0 + i, -3F);
         spiderNeck = new Cube(0, 0);
-        spiderNeck.addBox(-3F, -3F, -3F, 6, 6, 6, f);
+        spiderNeck.addBox(-3F, -3F, -3F, 6, 6, 6, expandAmount);
         spiderNeck.setRotationPoint(0.0F, i, 0.0F);
         spiderBody = new Cube(0, 12);
-        spiderBody.addBox(-5F, -4F, -6F, 10, 8, 12, f);
+        spiderBody.addBox(-5F, -4F, -6F, 10, 8, 12, expandAmount);
         spiderBody.setRotationPoint(0.0F, 0 + i, 9F);
         spiderLeg1 = new Cube(18, 0);
-        spiderLeg1.addBox(-15F, -1F, -1F, 16, 2, 2, f);
+        spiderLeg1.addBox(-15F, -1F, -1F, 16, 2, 2, expandAmount);
         spiderLeg1.setRotationPoint(-4F, 0 + i, 2.0F);
         spiderLeg2 = new Cube(18, 0);
-        spiderLeg2.addBox(-1F, -1F, -1F, 16, 2, 2, f);
+        spiderLeg2.addBox(-1F, -1F, -1F, 16, 2, 2, expandAmount);
         spiderLeg2.setRotationPoint(4F, 0 + i, 2.0F);
         spiderLeg3 = new Cube(18, 0);
-        spiderLeg3.addBox(-15F, -1F, -1F, 16, 2, 2, f);
+        spiderLeg3.addBox(-15F, -1F, -1F, 16, 2, 2, expandAmount);
         spiderLeg3.setRotationPoint(-4F, 0 + i, 1.0F);
         spiderLeg4 = new Cube(18, 0);
-        spiderLeg4.addBox(-1F, -1F, -1F, 16, 2, 2, f);
+        spiderLeg4.addBox(-1F, -1F, -1F, 16, 2, 2, expandAmount);
         spiderLeg4.setRotationPoint(4F, 0 + i, 1.0F);
         spiderLeg5 = new Cube(18, 0);
-        spiderLeg5.addBox(-15F, -1F, -1F, 16, 2, 2, f);
+        spiderLeg5.addBox(-15F, -1F, -1F, 16, 2, 2, expandAmount);
         spiderLeg5.setRotationPoint(-4F, 0 + i, 0.0F);
         spiderLeg6 = new Cube(18, 0);
-        spiderLeg6.addBox(-1F, -1F, -1F, 16, 2, 2, f);
+        spiderLeg6.addBox(-1F, -1F, -1F, 16, 2, 2, expandAmount);
         spiderLeg6.setRotationPoint(4F, 0 + i, 0.0F);
         spiderLeg7 = new Cube(18, 0);
-        spiderLeg7.addBox(-15F, -1F, -1F, 16, 2, 2, f);
+        spiderLeg7.addBox(-15F, -1F, -1F, 16, 2, 2, expandAmount);
         spiderLeg7.setRotationPoint(-4F, 0 + i, -1F);
         spiderLeg8 = new Cube(18, 0);
-        spiderLeg8.addBox(-1F, -1F, -1F, 16, 2, 2, f);
+        spiderLeg8.addBox(-1F, -1F, -1F, 16, 2, 2, expandAmount);
         spiderLeg8.setRotationPoint(4F, 0 + i, -1F);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/stitcher/TextureRegistry.java b/src/main/java/net/minecraft/client/render/stitcher/TextureRegistry.java
index 100726206..2fe4a0519 100644
--- a/src/main/java/net/minecraft/client/render/stitcher/TextureRegistry.java
+++ b/src/main/java/net/minecraft/client/render/stitcher/TextureRegistry.java
@@ -34,6 +34,18 @@ public class TextureRegistry {
 
         return atlas.getTexture(split1[0] + ":" + split2[1]);
     }
+    public static Boolean hasTexture(String key){
+        if (key == null) return null;
+
+        String[] split1 = key.split(":");
+        if (split1.length != 2) throw new IllegalArgumentException("Key '" + key + "' is improperly formatted! should follow the scheme 'key:atlas/id'");
+
+        String[] split2 = split1[1].split("/", 2);
+        AtlasStitcher atlas = stitcherMap.get(split2[0]);
+        if (atlas == null) throw new IllegalArgumentException("Failed to find atlas '" + split2[0] + "'!");
+
+        return atlas.textureMap.containsKey(split1[0] + ":" + split2[1]);
+    }
     public static AtlasStitcher register(String id, AtlasStitcher atlas){
         stitcherMap.put(id, atlas);
         return atlas;
diff --git a/src/main/java/net/minecraft/client/render/texturepack/TexturePackCustom.java b/src/main/java/net/minecraft/client/render/texturepack/TexturePackCustom.java
index d70e2a7d8..1a3774c65 100644
--- a/src/main/java/net/minecraft/client/render/texturepack/TexturePackCustom.java
+++ b/src/main/java/net/minecraft/client/render/texturepack/TexturePackCustom.java
@@ -190,7 +190,7 @@ public class TexturePackCustom extends TexturePack
             minecraft.renderEngine.bindTexture(thumbnailImage);
         } else
         {
-            GL11.glBindTexture(GL11.GL_TEXTURE_2D, minecraft.renderEngine.getTexture("/gui/unknown_pack.png"));
+            GL11.glBindTexture(GL11.GL_TEXTURE_2D, minecraft.renderEngine.getTexture("/assets/minecraft/textures/gui/unknown_pack.png"));
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/render/texturepack/TexturePackDefault.java b/src/main/java/net/minecraft/client/render/texturepack/TexturePackDefault.java
index b7e0c3cef..58749dd1f 100644
--- a/src/main/java/net/minecraft/client/render/texturepack/TexturePackDefault.java
+++ b/src/main/java/net/minecraft/client/render/texturepack/TexturePackDefault.java
@@ -52,7 +52,7 @@ public class TexturePackDefault extends TexturePack
         }
         else
         {
-            GL11.glBindTexture(GL11.GL_TEXTURE_2D, minecraft.renderEngine.getTexture("/gui/unknown_pack.png"));
+            GL11.glBindTexture(GL11.GL_TEXTURE_2D, minecraft.renderEngine.getTexture("/assets/minecraft/textures/gui/unknown_pack.png"));
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java
index 958efc0d4..dbcd6f4d4 100644
--- a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java
+++ b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java
@@ -54,7 +54,7 @@ public class TileEntityRendererFlag extends TileEntityRenderer<TileEntityFlag>
         final float scale = 1F;
         GL11.glTranslatef((float) x + 0.5F, (float) y + 0.75F * scale, (float) z + 0.5F);
         GL11.glScalef(scale, -scale, -scale);
-        loadTexture("/item/flag.png");
+        loadTexture("/assets/minecraft/textures/entity/flag.png");
         if (shortPole)
         {
             flagModel.renderPoleShort();
diff --git a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
index 4f8801ad8..c98681103 100644
--- a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
+++ b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
@@ -77,7 +77,7 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
         GL11.glNormal3f(0.0F, 0.0F, -1F * f4);
         GL11.glDepthMask(false);
         EnumSignPicture picture = tileEntity.getPicture();
-        renderDispatcher.renderEngine.bindTexture(renderDispatcher.renderEngine.getTexture("/gui/sign_images.png"));
+        renderDispatcher.renderEngine.bindTexture(renderDispatcher.renderEngine.getTexture("/assets/minecraft/textures/gui/sign_images.png"));
         drawTexturedModalRect(-48, -24, picture.getU(), picture.getV(), 48, 24);
         GL11.glPopMatrix();
         
diff --git a/src/main/java/net/minecraft/core/block/Block.java b/src/main/java/net/minecraft/core/block/Block.java
index de85fed6c..334b525cb 100644
--- a/src/main/java/net/minecraft/core/block/Block.java
+++ b/src/main/java/net/minecraft/core/block/Block.java
@@ -1219,6 +1219,8 @@ public class Block
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
     public static final Block trapdoorPlanksOakPainted = new BlockTrapDoorPainted("trapdoor.planks.oak.painted", 573, Material.wood).withHardness(3F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.MINEABLE_BY_AXE);
+    public static final Block trapdoorGlassTinted = new BlockTrapDoorTinted("trapdoor.glass.tinted", 574, Material.glass, false).withHardness(0.3F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
     public static final Block tnt = new BlockTNT("tnt", 580).withHardness(0.0F);
 
@@ -1238,6 +1240,10 @@ public class Block
             .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
     public static final Block doorGlassTop = new BlockDoorGlass("door.glass.top", 597, Material.glass, true).withHardness(0.3F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block doorGlassTintedBottom = new BlockDoorGlassTinted("door.glass.tinted.bottom", 598, Material.glass, false).withHardness(0.3F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
+            .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block doorGlassTintedTop = new BlockDoorGlassTinted("door.glass.tinted.top", 599, Material.glass, true).withHardness(0.3F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
+            .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
 
     public static final Block mesh = new BlockMesh("mesh", 600).withHardness(1.5F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CAN_HANG_OFF);
diff --git a/src/main/java/net/minecraft/core/block/BlockButton.java b/src/main/java/net/minecraft/core/block/BlockButton.java
index 7f06a83a9..79f0052fc 100644
--- a/src/main/java/net/minecraft/core/block/BlockButton.java
+++ b/src/main/java/net/minecraft/core/block/BlockButton.java
@@ -1,7 +1,5 @@
 package net.minecraft.core.block;
 
-import java.util.Random;
-
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.EntityLiving;
 import net.minecraft.core.entity.player.EntityPlayer;
@@ -9,8 +7,10 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
+
+import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            Block, Material, World, IBlockAccess, 
@@ -52,7 +52,13 @@ public class BlockButton extends Block
     @Override
     public boolean canPlaceBlockOnSide(World world, int x, int y, int z, int side)
     {
-        if(side == 2 && world.isBlockNormalCube(x, y, z + 1))
+        if (side == 0 && world.isBlockNormalCube(x, y + 1, z)){
+            return true;
+        }
+        else if (side == 1 && world.isBlockNormalCube(x, y - 1, z)){
+            return true;
+        }
+        else if(side == 2 && world.isBlockNormalCube(x, y, z + 1))
         {
             return true;
         }
@@ -70,6 +76,14 @@ public class BlockButton extends Block
     @Override
 	public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
+        if(world.isBlockNormalCube(x, y - 1, z))
+        {
+            return true;
+        }
+        if(world.isBlockNormalCube(x, y + 1, z))
+        {
+            return true;
+        }
         if(world.isBlockNormalCube(x - 1, y, z))
         {
             return true;
@@ -87,47 +101,51 @@ public class BlockButton extends Block
     
     @Override
     public void onBlockPlaced(World world, int x, int y, int z, Side side, EntityLiving entity, double sideHeight) {
-    	int l = side.getId();
         int i1 = world.getBlockMetadata(x, y, z);
         int j1 = i1 & 8;
         i1 &= 7;
-        if(l == 2 && world.isBlockNormalCube(x, y, z + 1))
-        {
+        if(side == Side.BOTTOM && world.isBlockNormalCube(x, y + 1, z)) {
+            i1 = 5;
+        } else if(side == Side.TOP && world.isBlockNormalCube(x, y - 1, z)) {
+            i1 = 6;
+        } else if(side == Side.NORTH && world.isBlockNormalCube(x, y, z + 1)) {
             i1 = 4;
-        } else
-        if(l == 3 && world.isBlockNormalCube(x, y, z - 1))
-        {
+        } else if(side == Side.SOUTH && world.isBlockNormalCube(x, y, z - 1)) {
             i1 = 3;
-        } else
-        if(l == 4 && world.isBlockNormalCube(x + 1, y, z))
-        {
+        } else if(side == Side.WEST && world.isBlockNormalCube(x + 1, y, z)) {
             i1 = 2;
-        } else
-        if(l == 5 && world.isBlockNormalCube(x - 1, y, z))
-        {
+        } else if(side == Side.EAST && world.isBlockNormalCube(x - 1, y, z)) {
             i1 = 1;
-        } else
-        {
+        } else {
             i1 = getOrientation(world, x, y, z);
         }
         world.setBlockMetadataWithNotify(x, y, z, i1 + j1);
     }
     
-    private int getOrientation(World world, int i, int j, int k)
+    private int getOrientation(World world, int x, int y, int z)
     {
-        if(world.isBlockNormalCube(i - 1, j, k))
+        if(world.isBlockNormalCube(x - 1, y, z))
         {
             return 1;
         }
-        if(world.isBlockNormalCube(i + 1, j, k))
+        if(world.isBlockNormalCube(x + 1, y, z))
         {
             return 2;
         }
-        if(world.isBlockNormalCube(i, j, k - 1))
+        if(world.isBlockNormalCube(x, y, z - 1))
         {
             return 3;
         }
-        return !world.isBlockNormalCube(i, j, k + 1) ? 1 : 4;
+        if (world.isBlockNormalCube(x, y, z + 1)){
+            return 4;
+        }
+        if (world.isBlockNormalCube(x, y + 1, z)){
+            return 5;
+        }
+        if (world.isBlockNormalCube(x, y - 1, z)){
+            return 6;
+        }
+        return 1;
     }
 
     @Override
@@ -153,6 +171,14 @@ public class BlockButton extends Block
             {
                 flag = true;
             }
+            if(!world.isBlockNormalCube(x, y + 1, z) && i1 == 5)
+            {
+                flag = true;
+            }
+            if(!world.isBlockNormalCube(x, y - 1, z) && i1 == 6)
+            {
+                flag = true;
+            }
             if(flag)
             {
                 dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, i1, null);
@@ -189,21 +215,18 @@ public class BlockButton extends Block
         {
             f3 = 0.0625F;
         }
-        if(i1 == 1)
-        {
+        if(i1 == 1) {
             setBlockBounds(0.0F, f, 0.5F - f2, f3, f1, 0.5F + f2);
-        } else
-        if(i1 == 2)
-        {
+        } else if(i1 == 2) {
             setBlockBounds(1.0F - f3, f, 0.5F - f2, 1.0F, f1, 0.5F + f2);
-        } else
-        if(i1 == 3)
-        {
+        } else if(i1 == 3) {
             setBlockBounds(0.5F - f2, f, 0.0F, 0.5F + f2, f1, f3);
-        } else
-        if(i1 == 4)
-        {
+        } else if(i1 == 4) {
             setBlockBounds(0.5F - f2, f, 1.0F - f3, 0.5F + f2, f1, 1.0F);
+        } else if(i1 == 5) { // Top
+            setBlockBounds(0.5f - f2, 1 - f3, f, 0.5f + f2, 1.0, f1);
+        } else if(i1 == 6) { // Bottom
+            setBlockBounds(0.5f - f2, 0, f, 0.5f + f2, f3, f1);
         }
     }
 
@@ -229,23 +252,17 @@ public class BlockButton extends Block
         world.markBlocksDirty(x, y, z, x, y, z);
         world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, (double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D, "random.click", 0.3F, 0.6F);
         world.notifyBlocksOfNeighborChange(x, y, z, id);
-        if(i1 == 1)
-        {
+        if(i1 == 1) {
             world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
-        } else
-        if(i1 == 2)
-        {
+        } else if(i1 == 2) {
             world.notifyBlocksOfNeighborChange(x + 1, y, z, id);
-        } else
-        if(i1 == 3)
-        {
+        } else if(i1 == 3) {
             world.notifyBlocksOfNeighborChange(x, y, z - 1, id);
-        } else
-        if(i1 == 4)
-        {
+        } else if(i1 == 4) {
             world.notifyBlocksOfNeighborChange(x, y, z + 1, id);
-        } else
-        {
+        } else if(i1 == 5) {
+            world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
+        } else {
             world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
         }
         world.scheduleBlockUpdate(x, y, z, id, tickRate());
@@ -259,23 +276,17 @@ public class BlockButton extends Block
         {
             world.notifyBlocksOfNeighborChange(x, y, z, id);
             int i1 = data & 7;
-            if(i1 == 1)
-            {
+            if(i1 == 1) {
                 world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
-            } else
-            if(i1 == 2)
-            {
+            } else if(i1 == 2) {
                 world.notifyBlocksOfNeighborChange(x + 1, y, z, id);
-            } else
-            if(i1 == 3)
-            {
+            } else if(i1 == 3) {
                 world.notifyBlocksOfNeighborChange(x, y, z - 1, id);
-            } else
-            if(i1 == 4)
-            {
+            } else if(i1 == 4) {
                 world.notifyBlocksOfNeighborChange(x, y, z + 1, id);
-            } else
-            {
+            } else if(i1 == 5) {
+                world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
+            } else {
                 world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
             }
         }
@@ -297,7 +308,11 @@ public class BlockButton extends Block
             return false;
         }
         int j1 = i1 & 7;
-        if(j1 == 5 && side == 1)
+        if(j1 == 6 && side == 1)
+        {
+            return true;
+        }
+        if(j1 == 5 && side == 0)
         {
             return true;
         }
@@ -337,25 +352,20 @@ public class BlockButton extends Block
         world.setBlockMetadataWithNotify(x, y, z, l & 7);
         world.notifyBlocksOfNeighborChange(x, y, z, id);
         int i1 = l & 7;
-        if(i1 == 1)
-        {
+        if(i1 == 1) {
             world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
-        } else
-        if(i1 == 2)
-        {
+        } else if(i1 == 2) {
             world.notifyBlocksOfNeighborChange(x + 1, y, z, id);
-        } else
-        if(i1 == 3)
-        {
+        } else if(i1 == 3) {
             world.notifyBlocksOfNeighborChange(x, y, z - 1, id);
-        } else
-        if(i1 == 4)
-        {
+        } else if(i1 == 4) {
             world.notifyBlocksOfNeighborChange(x, y, z + 1, id);
-        } else
-        {
+        } else if(i1 == 5) {
+            world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
+        } else {
             world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
         }
+
         world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D, "random.click", 0.3F, 0.5F);
         world.markBlocksDirty(x, y, z, x, y, z);
     }
diff --git a/src/main/java/net/minecraft/core/block/BlockDoorGlassTinted.java b/src/main/java/net/minecraft/core/block/BlockDoorGlassTinted.java
new file mode 100644
index 000000000..f010dde7f
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/BlockDoorGlassTinted.java
@@ -0,0 +1,30 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.world.World;
+
+public class BlockDoorGlassTinted extends BlockDoorGlass{
+    public BlockDoorGlassTinted(String key, int id, Material material, boolean isTop) {
+        super(key, id, material, isTop);
+    }
+    @Override
+    public boolean blocksLight()
+    {
+        return true;
+    }
+
+    @Override
+    public int getRenderBlockPass()
+    {
+        return 1;
+    }
+    @Override
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    {
+        return new ItemStack[] { new ItemStack(Item.doorGlassTinted) };
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/BlockJukeBox.java b/src/main/java/net/minecraft/core/block/BlockJukeBox.java
index 67fa6eb09..4ecbe18b0 100644
--- a/src/main/java/net/minecraft/core/block/BlockJukeBox.java
+++ b/src/main/java/net/minecraft/core/block/BlockJukeBox.java
@@ -53,14 +53,14 @@ public class BlockJukeBox extends BlockTileEntity
         int l = tileentityrecordplayer.record;
         if (l != 0) {
             world.playSoundEffect(1005, i, j, k, 0);
-            world.playRecord(null, i, j, k);
+            world.playRecord(null, null, i, j, k);
             tileentityrecordplayer.record = 0;
             tileentityrecordplayer.onInventoryChanged();
             world.setBlockMetadataWithNotify(i, j, k, 0);
             int i1 = l;
             float f = 0.7F;
             double d = (double) (world.rand.nextFloat() * f) + (double) (1.0F - f) * 0.5D;
-            double d1 = (double) (world.rand.nextFloat() * f) + (double) (1.0F - f) * 0.20000000000000001D + 0.59999999999999998D;
+            double d1 = (double) (world.rand.nextFloat() * f) + (double) (1.0F - f) * 0.2D + 0.6D;
             double d2 = (double) (world.rand.nextFloat() * f) + (double) (1.0F - f) * 0.5D;
             EntityItem entityitem = new EntityItem(world, (double) i + d, (double) j + d1, (double) k + d2, new ItemStack(i1, 1, 0));
             entityitem.delayBeforeCanPickup = 10;
diff --git a/src/main/java/net/minecraft/core/block/BlockLever.java b/src/main/java/net/minecraft/core/block/BlockLever.java
index 7333aa2eb..c0dc45b1f 100644
--- a/src/main/java/net/minecraft/core/block/BlockLever.java
+++ b/src/main/java/net/minecraft/core/block/BlockLever.java
@@ -44,22 +44,11 @@ public class BlockLever extends Block
     @Override
     public boolean canPlaceBlockOnSide(World world, int x, int y, int z, int side)
     {
-        if(side == 1 && world.canPlaceOnSurfaceOfBlock(x, y - 1, z))
-        {
-            return true;
-        }
-        if(side == 2 && world.isBlockNormalCube(x, y, z + 1))
-        {
-            return true;
-        }
-        if(side == 3 && world.isBlockNormalCube(x, y, z - 1))
-        {
-            return true;
-        }
-        if(side == 4 && world.isBlockNormalCube(x + 1, y, z))
-        {
-            return true;
-        }
+        if (side == 0 && world.isBlockNormalCube(x, y + 1, z)){return true;}
+        if(side == 1 && world.canPlaceOnSurfaceOfBlock(x, y - 1, z)) {return true;}
+        if(side == 2 && world.isBlockNormalCube(x, y, z + 1)) {return true;}
+        if(side == 3 && world.isBlockNormalCube(x, y, z - 1)) {return true;}
+        if(side == 4 && world.isBlockNormalCube(x + 1, y, z)) {return true;}
         return side == 5 && world.isBlockNormalCube(x - 1, y, z);
     }
 
@@ -67,49 +56,41 @@ public class BlockLever extends Block
     @Override
 	public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
-        if(world.isBlockNormalCube(x - 1, y, z))
-        {
-            return true;
-        }
-        if(world.isBlockNormalCube(x + 1, y, z))
-        {
-            return true;
-        }
-        if(world.isBlockNormalCube(x, y, z - 1))
-        {
-            return true;
-        }
-        if(world.isBlockNormalCube(x, y, z + 1))
-        {
-            return true;
-        }
+        if(world.isBlockNormalCube(x - 1, y, z)) {return true;}
+        if(world.isBlockNormalCube(x + 1, y, z)) {return true;}
+        if(world.isBlockNormalCube(x, y, z - 1)) {return true;}
+        if(world.isBlockNormalCube(x, y, z + 1)) {return true;}
+        if (world.isBlockNormalCube(x, y + 1, z)) return true;
         return world.canPlaceOnSurfaceOfBlock(x, y - 1, z);
     }
     
     @Override
     public void onBlockPlaced(World world, int x, int y, int z, Side side, EntityLiving entity, double sideHeight) {
-    	int l = side.getId();
         int i1 = world.getBlockMetadata(x, y, z);
-        int j1 = i1 & 8;
-        i1 &= 7;
+        int j1 = i1 & 16;
+        i1 &= 15;
         i1 = -1;
-        if(l == 1 && world.canPlaceOnSurfaceOfBlock(x, y - 1, z))
+        if(side == Side.BOTTOM && world.canPlaceOnSurfaceOfBlock(x, y + 1, z))
+        {
+            i1 = 7 + (entity.getHorizontalPlacementDirection(side).getAxis() == Axis.Z ? 1 : 0);
+        }
+        if(side == Side.TOP && world.canPlaceOnSurfaceOfBlock(x, y - 1, z))
         {
             i1 = 5 + (entity.getHorizontalPlacementDirection(side).getAxis() == Axis.Z ? 1 : 0);
         }
-        if(l == 2 && world.isBlockNormalCube(x, y, z + 1))
+        if(side == Side.NORTH && world.isBlockNormalCube(x, y, z + 1))
         {
             i1 = 4;
         }
-        if(l == 3 && world.isBlockNormalCube(x, y, z - 1))
+        if(side == Side.SOUTH && world.isBlockNormalCube(x, y, z - 1))
         {
             i1 = 3;
         }
-        if(l == 4 && world.isBlockNormalCube(x + 1, y, z))
+        if(side == Side.WEST && world.isBlockNormalCube(x + 1, y, z))
         {
             i1 = 2;
         }
-        if(l == 5 && world.isBlockNormalCube(x - 1, y, z))
+        if(side == Side.EAST && world.isBlockNormalCube(x - 1, y, z))
         {
             i1 = 1;
         }
@@ -128,7 +109,7 @@ public class BlockLever extends Block
     {
         if(checkIfAttachedToBlock(world, x, y, z))
         {
-            int i1 = world.getBlockMetadata(x, y, z) & 7;
+            int i1 = world.getBlockMetadata(x, y, z) & 15;
             boolean flag = false;
             if(!world.isBlockNormalCube(x - 1, y, z) && i1 == 1)
             {
@@ -154,6 +135,14 @@ public class BlockLever extends Block
             {
                 flag = true;
             }
+            if(!world.canPlaceOnSurfaceOfBlock(x, y + 1, z) && i1 == 7)
+            {
+                flag = true;
+            }
+            if(!world.canPlaceOnSurfaceOfBlock(x, y + 1, z) && i1 == 8)
+            {
+                flag = true;
+            }
             if(flag)
             {
                 dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null);
@@ -178,27 +167,22 @@ public class BlockLever extends Block
     @Override
     public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
     {
-        int l = world.getBlockMetadata(x, y, z) & 7;
+        int l = world.getBlockMetadata(x, y, z) & 15;
         float f = 0.1875F;
-        if(l == 1)
-        {
+        if(l == 1) {
             setBlockBounds(0.0F, 0.2F, 0.5F - f, f * 2.0F, 0.8F, 0.5F + f);
-        } else
-        if(l == 2)
-        {
+        } else if(l == 2) {
             setBlockBounds(1.0F - f * 2.0F, 0.2F, 0.5F - f, 1.0F, 0.8F, 0.5F + f);
-        } else
-        if(l == 3)
-        {
+        } else if(l == 3) {
             setBlockBounds(0.5F - f, 0.2F, 0.0F, 0.5F + f, 0.8F, f * 2.0F);
-        } else
-        if(l == 4)
-        {
+        } else if(l == 4) {
             setBlockBounds(0.5F - f, 0.2F, 1.0F - f * 2.0F, 0.5F + f, 0.8F, 1.0F);
-        } else
-        {
+        } else if (l == 5 || l == 6) {
             float f1 = 0.25F;
             setBlockBounds(0.5F - f1, 0.0F, 0.5F - f1, 0.5F + f1, 0.6F, 0.5F + f1);
+        } else {
+            float f1 = 0.25F;
+            setBlockBounds(0.5F - f1, 0.4, 0.5F - f1, 0.5F + f1, 1F, 0.5F + f1);
         }
     }
 
@@ -214,30 +198,24 @@ public class BlockLever extends Block
     public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
     {
         int l = world.getBlockMetadata(x, y, z);
-        int i1 = l & 7;
-        int j1 = 8 - (l & 8);
+        int i1 = l & 15;
+        int j1 = 16 - (l & 16);
         world.setBlockMetadataWithNotify(x, y, z, i1 + j1);
         world.markBlocksDirty(x, y, z, x, y, z);
         world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, (double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D, "random.click", 0.3F, j1 <= 0 ? 0.5F : 0.6F);
         world.notifyBlocksOfNeighborChange(x, y, z, id);
-        if(i1 == 1)
-        {
+        if(i1 == 1) {
             world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
-        } else
-        if(i1 == 2)
-        {
+        } else if(i1 == 2) {
             world.notifyBlocksOfNeighborChange(x + 1, y, z, id);
-        } else
-        if(i1 == 3)
-        {
+        } else if(i1 == 3) {
             world.notifyBlocksOfNeighborChange(x, y, z - 1, id);
-        } else
-        if(i1 == 4)
-        {
+        } else if(i1 == 4) {
             world.notifyBlocksOfNeighborChange(x, y, z + 1, id);
-        } else
-        {
+        } else if (i1 == 5 || i1 == 6){
             world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+        } else {
+            world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
         }
         return true;
     }
@@ -245,28 +223,22 @@ public class BlockLever extends Block
     @Override
     public void onBlockRemoved(World world, int x, int y, int z, int data)
     {
-        if((data & 8) > 0)
+        if((data & 16) > 0)
         {
             world.notifyBlocksOfNeighborChange(x, y, z, id);
-            int i1 = data & 7;
-            if(i1 == 1)
-            {
+            int i1 = data & 15;
+            if(i1 == 1) {
                 world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
-            } else
-            if(i1 == 2)
-            {
+            } else if(i1 == 2) {
                 world.notifyBlocksOfNeighborChange(x + 1, y, z, id);
-            } else
-            if(i1 == 3)
-            {
+            } else if(i1 == 3) {
                 world.notifyBlocksOfNeighborChange(x, y, z - 1, id);
-            } else
-            if(i1 == 4)
-            {
+            } else if(i1 == 4) {
                 world.notifyBlocksOfNeighborChange(x, y, z + 1, id);
-            } else
-            {
+            } else if (i1 == 5 || i1 == 6){
                 world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+            } else {
+                world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
             }
         }
         super.onBlockRemoved(world, x, y, z, data);
@@ -275,18 +247,26 @@ public class BlockLever extends Block
     @Override
     public boolean isPoweringTo(WorldSource blockAccess, int x, int y, int z, int side)
     {
-        return (blockAccess.getBlockMetadata(x, y, z) & 8) > 0;
+        return (blockAccess.getBlockMetadata(x, y, z) & 16) > 0;
     }
 
     @Override
     public boolean isIndirectlyPoweringTo(World world, int x, int y, int z, int side)
     {
         int i1 = world.getBlockMetadata(x, y, z);
-        if((i1 & 8) == 0)
+        if((i1 & 16) == 0)
         {
             return false;
         }
-        int j1 = i1 & 7;
+        int j1 = i1 & 15;
+        if(j1 == 8 && side == 0)
+        {
+            return true;
+        }
+        if(j1 == 7 && side == 0)
+        {
+            return true;
+        }
         if(j1 == 6 && side == 1)
         {
             return true;
